ASN1Sequence (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.asn1

## Class ASN1Sequence

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.ASN1Primitive
    - - org.bouncycastle.asn1.ASN1Sequence

- All Implemented Interfaces:
    java.lang.Iterable<ASN1Encodable>, ASN1Encodable, Encodable
  Direct Known Subclasses:
    BERSequence, DERSequence, DLSequence

      public abstract class ASN1Sequence
      extends ASN1Primitive
      implements Iterable<ASN1Encodable>

  ASN.1 `SEQUENCE` and `SEQUENCE OF` constructs.

  DER form is always definite form length fields, while BER support uses indefinite form.

  X.690

  8: Basic encoding rules

  8.9 Encoding of a sequence value

  8.9.1 The encoding of a sequence value shall be constructed.

  8.9.2 The contents octets shall consist of the complete encoding of one data value from each of the types listed in the ASN.1 definition of the sequence type, in the order of their appearance in the definition, unless the type was referenced with the keyword OPTIONAL or the keyword DEFAULT.

  8.9.3 The encoding of a data value may, but need not, be present for a type which was referenced with the keyword OPTIONAL or the keyword DEFAULT. If present, it shall appear in the encoding at the point corresponding to the appearance of the type in the ASN.1 definition.

  8.10 Encoding of a sequence-of value

  8.10.1 The encoding of a sequence-of value shall be constructed.

  8.10.2 The contents octets shall consist of zero, one or more complete encodings of data values from the type listed in the ASN.1 definition.

  8.10.3 The order of the encodings of the data values shall be the same as the order of the data values in the sequence-of value to be encoded.

  9: Canonical encoding rules

  9.1 Length forms

  If the encoding is constructed, it shall employ the indefinite-length form. If the encoding is primitive, it shall include the fewest length octets necessary. [Contrast with 8.1.3.2 b).]

  11: Restrictions on BER employed by both CER and DER

  11.5 Set and sequence components with default value

  The encoding of a set value or sequence value shall not include an encoding for any component value which is equal to its default value.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Vector` | `seq`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ASN1Sequence()` Create an empty sequence
    `protected` | `ASN1Sequence(ASN1Encodable obj)` Create a sequence containing one object
    `protected` | `ASN1Sequence(ASN1Encodable[] array)`
    `protected` | `ASN1Sequence(ASN1EncodableVector v)` Create a sequence containing a vector of objects.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ASN1Sequence` | `getInstance(ASN1TaggedObject obj, boolean explicit)` Return an ASN1 sequence from a tagged object.
    `static ASN1Sequence` | `getInstance(java.lang.Object obj)` Return an ASN1Sequence from the given object.
    `ASN1Encodable` | `getObjectAt(int index)` Return the object at the sequence position indicated by index.
    `java.util.Enumeration` | `getObjects()`
    `int` | `hashCode()`
    `java.util.Iterator<ASN1Encodable>` | `iterator()` Returns an iterator over a set of elements of type T.
    `ASN1SequenceParser` | `parser()`
    `int` | `size()` Return the number of objects in this sequence.
    `ASN1Encodable[]` | `toArray()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Primitive

      `equals, fromByteArray, toASN1Primitive`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `getEncoded, getEncoded, hasEncodedTagValue, toASN1Object`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### seq

          protected java.util.Vector seq

  - ### Constructor Detail

    - #### ASN1Sequence

          protected ASN1Sequence()

      Create an empty sequence

    - #### ASN1Sequence

          protected ASN1Sequence(ASN1Encodable obj)

      Create a sequence containing one object
      Parameters:
        `obj` - the object to be put in the SEQUENCE.

    - #### ASN1Sequence

          protected ASN1Sequence(ASN1EncodableVector v)

      Create a sequence containing a vector of objects.
      Parameters:
        `v` - the vector of objects to be put in the SEQUENCE

    - #### ASN1Sequence

          protected ASN1Sequence(ASN1Encodable[] array)

  - ### Method Detail

    - #### getInstance

          public static ASN1Sequence getInstance(java.lang.Object obj)

      Return an ASN1Sequence from the given object.
      Parameters:
        `obj` - the object we want converted.
      Returns:
        an ASN1Sequence instance, or null.
      Throws:
        `java.lang.IllegalArgumentException` - if the object cannot be converted.

    - #### getInstance

          public static ASN1Sequence getInstance(ASN1TaggedObject obj,
                                 boolean explicit)

      Return an ASN1 sequence from a tagged object. There is a special case here, if an object appears to have been explicitly tagged on reading but we were expecting it to be implicitly tagged in the normal course of events it indicates that we lost the surrounding sequence - so we need to add it back (this will happen if the tagged object is a sequence that contains other sequences). If you are dealing with implicitly tagged sequences you really should be using this method.
      Parameters:
        `obj` - the tagged object.
        `explicit` - true if the object is meant to be explicitly tagged, false otherwise.
      Returns:
        an ASN1Sequence instance.
      Throws:
        `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.

    - #### toArray

          public ASN1Encodable[] toArray()

    - #### getObjects

          public java.util.Enumeration getObjects()

    - #### parser

          public ASN1SequenceParser parser()

    - #### getObjectAt

          public ASN1Encodable getObjectAt(int index)

      Return the object at the sequence position indicated by index.
      Parameters:
        `index` - the sequence number (starting at zero) of the object
      Returns:
        the object at the sequence position indicated by index.

    - #### size

          public int size()

      Return the number of objects in this sequence.
      Returns:
        the number of objects in this sequence.

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `ASN1Primitive`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### iterator

          public java.util.Iterator<ASN1Encodable> iterator()

      Description copied from interface: `Iterable`
      Returns an iterator over a set of elements of type T.
      Specified by:
        `iterator` in interface `java.lang.Iterable<ASN1Encodable>`
      Returns:
        an Iterator.